#ifndef output_utility_h
#define output_utility_h

#include <vector>
#include <string>

using namespace std;

extern string UnitLablesDetailed[];
extern string TitleLablesDetailed[];
extern string UnitLables[];
extern string TitleLables[];
void GetIndicesFromTitles(vector<string> &dtitles, vector<string> &dunits, 
    vector<string> &stitles, vector<string> &sunits, vector<int> &widths, vector<int> &precs);

enum {
    Gap_ = 0,
    HEnergy_,
    Energy_,
    Energycv_,
	ThetaXY_,
    ThetaX_,
    ThetaY_,
	DistXY_,
    DistX_,
    DistY_,
    R_,
    Theta_,
    Phi_,
    Ky_,
    Kx_,
    Kvalue_,
    NearFldens_,
    NearLinFldens_,

    ReNearFldens_,
    ReNearLinFldens_,

    NearPwdens_,
    NearFpwdens_,
    Fldens_,
    LinFldens_,
    Pwdens_,
    Fpwdens_,
    ResPwdensX_,
    ResPwdensY_,
    GABrill_,
	WBrill_,
	Brill1D_,
    Flux_ev_,
    Flux_,
    Ipower_,
    Iflux_,
    Avdens_,
    Avbrill_,
    Pl_,
    Pc_,
    Pl45_,
    Pl_1_,
    Fldensx_,
    Fldensy_,
    Power_,
    FPower_,
    Tpower_,
    Cohsize_,
    Cohdiv_,
    Sizex_,
    Sizey_,
    Divx_,
    Divy_,
    Cflux_,
    Cpower_,
    Z_,
    Bx_,
    By_,
    Bz_,
    Betax_,
    Betay_,
    X_,
    Y_,
    Efieldx_,
    Efieldy_,
    Obstime_,
    FieldRex_,
    FieldImx_,
    FieldRey_,
    FieldImy_,
	CohFractionX_,
	CohFractionY_,
	SrcX_,
	SrcY_,
	SrcQX_,
	SrcQY_,
	Correlation_,
	DegCoh_,
	DegCohX_,
	DegCohY_,
	AptDX_,
	AptDY_,
	LongPos_,
    FarEfieldx_,
    FarEfieldy_,
	DistDepth_,
	VolPowerDens_,
	Harmonic_,
    PoleNo_,
    PhaseErr_,
    Transmission_,
    twiss_betax_,
    twiss_betay_,
    Absorption_,
    Filtered_,
    ModalAmpRe_,
    ModalAmpIm_,
    ModeOrder_,
	ReWBrill_,
	ReBrill1D_,
    ModeNumber_,
    ModalFlux_,
    ModalIFlux_,
    NormIntPhase_,
    NormIntGPhase_,
    FELZStep_,
    FELTime_,
    FELEta_,
    FELCurrent_,
    FELEtProf_,
    FELBFactorRe_,
    FELBFactorIm_,
    FELPulseEnergyRad_,
    FELPulseEnergyBeam_,
    FELPulseEnergyDens_,
    Xn_,
    Yn_,
    Xavg_,
    Yavg_,
    Xdiff_,
    Ydiff_,
    Xnavg_,
    Ynavg_,
    Xndiff_,
    Yndiff_,
    CSD_,
    CSDphase_,
    DegCohR_,

    BeamSizeX_,
    BeamSizeY_,
    NumberTitles
};

#endif
